from app import app
from os import sep
from pyrogram import filters
from pyrogram.types import ReplyKeyboardMarkup
from modules.utils import jsonLoad, jsonSave, configGet, configSet, locale, logWrite

# Start command ================================================================================================================
@app.on_message(~ filters.scheduled & filters.private & filters.command(["start"], prefixes=["/"]))
async def cmd_start(app, msg):

    try:
        user_stage = configGet("stage", file=str(msg.from_user.id))
        if user_stage != 0:
            return
    except FileNotFoundError:
        jsonSave(jsonLoad(f"{configGet('data', 'locations')}{sep}user_default.json"), f"{configGet('data', 'locations')}{sep}users{sep}{msg.from_user.id}.json")
        user_stage = configGet("stage", file=str(msg.from_user.id))
        configSet(["telegram_id"], str(msg.from_user.username), file=str(msg.from_user.id))
        configSet(["telegram_name"], f"{msg.from_user.first_name} {msg.from_user.last_name}", file=str(msg.from_user.id))
        configSet(["telegram_phone"], str(msg.from_user.phone_number), file=str(msg.from_user.id))
        configSet(["telegram_locale"], str(msg.from_user.language_code), file=str(msg.from_user.id))

    logWrite(f"User {msg.from_user.id} started bot interaction")
    await msg.reply_text(locale("start", "message"), reply_markup=ReplyKeyboardMarkup(locale("welcome", "keyboard"), resize_keyboard=True))
# ==============================================================================================================================