from os import sep, path
from dateutil.relativedelta import relativedelta
from datetime import datetime
from app import app, isAnAdmin
from pyrogram import filters
from modules.utils import configGet, jsonLoad, locale, logWrite

# Contact getting ==============================================================================================================
@app.on_message(~ filters.scheduled & filters.contact & filters.private)
async def get_contact(app, msg):
    if (path.exists(f"{configGet('data', 'locations')}{sep}users{sep}{msg.from_user.id}.json") and jsonLoad(f"{configGet('data', 'locations')}{sep}users{sep}{msg.from_user.id}.json")["approved"]) or (await isAnAdmin(msg.from_user.id)):
        if msg.contact.user_id != None:
            try:
                user_data = jsonLoad(f"{configGet('data', 'locations')}{sep}users{sep}{msg.contact.user_id}.json")
                application = jsonLoad(f"{configGet('data', 'locations')}{sep}applications.json")[str(msg.contact.user_id)]
                application_content = []
                i = 1
                for question in application["application"]:
                    if i == 2:
                        age = relativedelta(datetime.now(), datetime.strptime(application['application']['2'], '%d.%m.%Y'))
                        application_content.append(f"{locale('question'+str(i), 'message', 'question_titles')} {application['application']['2']} ({age.years} р.)")
                    else:
                        application_content.append(f"{locale('question'+str(i), 'message', 'question_titles')} {application['application'][question]}")
                    i += 1
                if user_data["sent"]:
                    if user_data["approved"]:
                        application_status = locale("application_status_accepted", "message").format((await app.get_users(application["approved_by"])).first_name, datetime.fromtimestamp(application["approval_date"]).strftime("%d.%m.%Y, %H:%M")) 
                    elif application["refused"]:
                        application_status = locale("application_status_refused", "message").format((await app.get_users(application["refused_by"])).first_name, datetime.fromtimestamp(application["refusal_date"]).strftime("%d.%m.%Y, %H:%M")) 
                    else:
                        application_status = locale("application_status_on_hold", "message")
                else:
                    if user_data["approved"]:
                        application_status = locale("application_status_accepted", "message").format((await app.get_users(application["approved_by"])).first_name, datetime.fromtimestamp(application["approval_date"]).strftime("%d.%m.%Y, %H:%M")) 
                    elif application["refused"]:
                        application_status = locale("application_status_refused", "message").format((await app.get_users(application["refused_by"])).first_name, datetime.fromtimestamp(application["refusal_date"]).strftime("%d.%m.%Y, %H:%M")) 
                    else:
                        application_status = locale("application_status_not_send", "message")
                logWrite(f"User {msg.from_user.id} requested application of {msg.contact.user_id}")
                await msg.reply_text(locale("contact", "message").format(str(msg.contact.user_id), "\n".join(application_content), application_status)) 
            except FileNotFoundError:
                logWrite(f"User {msg.from_user.id} requested application of {msg.contact.user_id} but user does not exists")
                await msg.reply_text(locale("contact_invalid", "message"))
        else:
            logWrite(f"User {msg.from_user.id} requested application of someone but user is not telegram user")
            await msg.reply_text(locale("contact_not_member", "message"))
# ==============================================================================================================================